#!/usr/bin/perl
####################################################################
#
#    This file was generated using Parse::Yapp version 1.05.
#
#        Don't edit this file, use source file instead.
#
#             ANY CHANGE MADE HERE WILL BE LOST !
#
####################################################################
package W3C::Rdf::AlgaeParser;
use vars qw ( @ISA );
use strict;

@ISA= qw ( Parse::Yapp::Driver );
#Included Parse/Yapp/Driver.pm file----------------------------------------
{
#
# Module Parse::Yapp::Driver
#
# This module is part of the Parse::Yapp package available on your
# nearest CPAN
#
# Any use of this module in a standalone parser make the included
# text under the same copyright as the Parse::Yapp module itself.
#
# This notice should remain unchanged.
#
# (c) Copyright 1998-2001 Francois Desarmenien, all rights reserved.
# (see the pod text in Parse::Yapp module for use and distribution rights)
#

package Parse::Yapp::Driver;

require 5.004;

use strict;

use vars qw ( $VERSION $COMPATIBLE $FILENAME );

$VERSION = '1.05';
$COMPATIBLE = '0.07';
$FILENAME=__FILE__;

use Carp;

#Known parameters, all starting with YY (leading YY will be discarded)
my(%params)=(YYLEX => 'CODE', 'YYERROR' => 'CODE', YYVERSION => '',
			 YYRULES => 'ARRAY', YYSTATES => 'ARRAY', YYDEBUG => '');
#Mandatory parameters
my(@params)=('LEX','RULES','STATES');

sub new {
    my($class)=shift;
	my($errst,$nberr,$token,$value,$check,$dotpos);
    my($self)={ ERROR => \&_Error,
				ERRST => \$errst,
                NBERR => \$nberr,
				TOKEN => \$token,
				VALUE => \$value,
				DOTPOS => \$dotpos,
				STACK => [],
				DEBUG => 0,
				CHECK => \$check };

	_CheckParams( [], \%params, \@_, $self );

		exists($$self{VERSION})
	and	$$self{VERSION} < $COMPATIBLE
	and	croak "Yapp driver version $VERSION ".
			  "incompatible with version $$self{VERSION}:\n".
			  "Please recompile parser module.";

        ref($class)
    and $class=ref($class);

    bless($self,$class);
}

sub YYParse {
    my($self)=shift;
    my($retval);

	_CheckParams( \@params, \%params, \@_, $self );

	if($$self{DEBUG}) {
		_DBLoad();
		$retval = eval '$self->_DBParse()';#Do not create stab entry on compile
        $@ and die $@;
	}
	else {
		$retval = $self->_Parse();
	}
    $retval
}

sub YYData {
	my($self)=shift;

		exists($$self{USER})
	or	$$self{USER}={};

	$$self{USER};
	
}

sub YYErrok {
	my($self)=shift;

	${$$self{ERRST}}=0;
    undef;
}

sub YYNberr {
	my($self)=shift;

	${$$self{NBERR}};
}

sub YYRecovering {
	my($self)=shift;

	${$$self{ERRST}} != 0;
}

sub YYAbort {
	my($self)=shift;

	${$$self{CHECK}}='ABORT';
    undef;
}

sub YYAccept {
	my($self)=shift;

	${$$self{CHECK}}='ACCEPT';
    undef;
}

sub YYError {
	my($self)=shift;

	${$$self{CHECK}}='ERROR';
    undef;
}

sub YYSemval {
	my($self)=shift;
	my($index)= $_[0] - ${$$self{DOTPOS}} - 1;

		$index < 0
	and	-$index <= @{$$self{STACK}}
	and	return $$self{STACK}[$index][1];

	undef;	#Invalid index
}

sub YYCurtok {
	my($self)=shift;

        @_
    and ${$$self{TOKEN}}=$_[0];
    ${$$self{TOKEN}};
}

sub YYCurval {
	my($self)=shift;

        @_
    and ${$$self{VALUE}}=$_[0];
    ${$$self{VALUE}};
}

sub YYExpect {
    my($self)=shift;

    keys %{$self->{STATES}[$self->{STACK}[-1][0]]{ACTIONS}}
}

sub YYLexer {
    my($self)=shift;

	$$self{LEX};
}


#################
# Private stuff #
#################


sub _CheckParams {
	my($mandatory,$checklist,$inarray,$outhash)=@_;
	my($prm,$value);
	my($prmlst)={};

	while(($prm,$value)=splice(@$inarray,0,2)) {
        $prm=uc($prm);
			exists($$checklist{$prm})
		or	croak("Unknow parameter '$prm'");
			ref($value) eq $$checklist{$prm}
		or	croak("Invalid value for parameter '$prm'");
        $prm=unpack('@2A*',$prm);
		$$outhash{$prm}=$value;
	}
	for (@$mandatory) {
			exists($$outhash{$_})
		or	croak("Missing mandatory parameter '".lc($_)."'");
	}
}

sub _Error {
	print "Parse error.\n";
}

sub _DBLoad {
	{
		no strict 'refs';

			exists(${__PACKAGE__.'::'}{_DBParse})#Already loaded ?
		and	return;
	}
	my($fname)=__FILE__;
	my(@drv);
	open(DRV,"<$fname") or die "Report this as a BUG: Cannot open $fname";
	while(<DRV>) {
                	/^\s*sub\s+_Parse\s*{\s*$/ .. /^\s*}\s*#\s*_Parse\s*$/
        	and     do {
                	s/^#DBG>//;
                	push(@drv,$_);
        	}
	}
	close(DRV);

	$drv[0]=~s/_P/_DBP/;
	eval join('',@drv);
}

#Note that for loading debugging version of the driver,
#this file will be parsed from 'sub _Parse' up to '}#_Parse' inclusive.
#So, DO NOT remove comment at end of sub !!!
sub _Parse {
    my($self)=shift;

	my($rules,$states,$lex,$error)
     = @$self{ 'RULES', 'STATES', 'LEX', 'ERROR' };
	my($errstatus,$nberror,$token,$value,$stack,$check,$dotpos)
     = @$self{ 'ERRST', 'NBERR', 'TOKEN', 'VALUE', 'STACK', 'CHECK', 'DOTPOS' };

#DBG>	my($debug)=$$self{DEBUG};
#DBG>	my($dbgerror)=0;

#DBG>	my($ShowCurToken) = sub {
#DBG>		my($tok)='>';
#DBG>		for (split('',$$token)) {
#DBG>			$tok.=		(ord($_) < 32 or ord($_) > 126)
#DBG>					?	sprintf('<%02X>',ord($_))
#DBG>					:	$_;
#DBG>		}
#DBG>		$tok.='<';
#DBG>	};

	$$errstatus=0;
	$$nberror=0;
	($$token,$$value)=(undef,undef);
	@$stack=( [ 0, undef ] );
	$$check='';

    while(1) {
        my($actions,$act,$stateno);

        $stateno=$$stack[-1][0];
        $actions=$$states[$stateno];

#DBG>	print STDERR ('-' x 40),"\n";
#DBG>		$debug & 0x2
#DBG>	and	print STDERR "In state $stateno:\n";
#DBG>		$debug & 0x08
#DBG>	and	print STDERR "Stack:[".
#DBG>					 join(',',map { $$_[0] } @$stack).
#DBG>					 "]\n";


        if  (exists($$actions{ACTIONS})) {

				defined($$token)
            or	do {
				($$token,$$value)=&$lex($self);
#DBG>				$debug & 0x01
#DBG>			and	print STDERR "Need token. Got ".&$ShowCurToken."\n";
			};

            $act=   exists($$actions{ACTIONS}{$$token})
                    ?   $$actions{ACTIONS}{$$token}
                    :   exists($$actions{DEFAULT})
                        ?   $$actions{DEFAULT}
                        :   undef;
        }
        else {
            $act=$$actions{DEFAULT};
#DBG>			$debug & 0x01
#DBG>		and	print STDERR "Don't need token.\n";
        }

            defined($act)
        and do {

                $act > 0
            and do {        #shift

#DBG>				$debug & 0x04
#DBG>			and	print STDERR "Shift and go to state $act.\n";

					$$errstatus
				and	do {
					--$$errstatus;

#DBG>					$debug & 0x10
#DBG>				and	$dbgerror
#DBG>				and	$$errstatus == 0
#DBG>				and	do {
#DBG>					print STDERR "**End of Error recovery.\n";
#DBG>					$dbgerror=0;
#DBG>				};
				};


                push(@$stack,[ $act, $$value ]);

					$$token ne ''	#Don't eat the eof
				and	$$token=$$value=undef;
                next;
            };

            #reduce
            my($lhs,$len,$code,@sempar,$semval);
            ($lhs,$len,$code)=@{$$rules[-$act]};

#DBG>			$debug & 0x04
#DBG>		and	$act
#DBG>		and	print STDERR "Reduce using rule ".-$act." ($lhs,$len): ";

                $act
            or  $self->YYAccept();

            $$dotpos=$len;

                unpack('A1',$lhs) eq '@'    #In line rule
            and do {
                    $lhs =~ /^\@[0-9]+\-([0-9]+)$/
                or  die "In line rule name '$lhs' ill formed: ".
                        "report it as a BUG.\n";
                $$dotpos = $1;
            };

            @sempar =       $$dotpos
                        ?   map { $$_[1] } @$stack[ -$$dotpos .. -1 ]
                        :   ();

            $semval = $code ? &$code( $self, @sempar )
                            : @sempar ? $sempar[0] : undef;

            splice(@$stack,-$len,$len);

                $$check eq 'ACCEPT'
            and do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Accept.\n";

				return($semval);
			};

                $$check eq 'ABORT'
            and	do {

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Abort.\n";

				return(undef);

			};

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Back to state $$stack[-1][0], then ";

                $$check eq 'ERROR'
            or  do {
#DBG>				$debug & 0x04
#DBG>			and	print STDERR 
#DBG>				    "go to state $$states[$$stack[-1][0]]{GOTOS}{$lhs}.\n";

#DBG>				$debug & 0x10
#DBG>			and	$dbgerror
#DBG>			and	$$errstatus == 0
#DBG>			and	do {
#DBG>				print STDERR "**End of Error recovery.\n";
#DBG>				$dbgerror=0;
#DBG>			};

			    push(@$stack,
                     [ $$states[$$stack[-1][0]]{GOTOS}{$lhs}, $semval ]);
                $$check='';
                next;
            };

#DBG>			$debug & 0x04
#DBG>		and	print STDERR "Forced Error recovery.\n";

            $$check='';

        };

        #Error
            $$errstatus
        or   do {

            $$errstatus = 1;
            &$error($self);
                $$errstatus # if 0, then YYErrok has been called
            or  next;       # so continue parsing

#DBG>			$debug & 0x10
#DBG>		and	do {
#DBG>			print STDERR "**Entering Error recovery.\n";
#DBG>			++$dbgerror;
#DBG>		};

            ++$$nberror;

        };

			$$errstatus == 3	#The next token is not valid: discard it
		and	do {
				$$token eq ''	# End of input: no hope
			and	do {
#DBG>				$debug & 0x10
#DBG>			and	print STDERR "**At eof: aborting.\n";
				return(undef);
			};

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Dicard invalid token ".&$ShowCurToken.".\n";

			$$token=$$value=undef;
		};

        $$errstatus=3;

		while(	  @$stack
			  and (		not exists($$states[$$stack[-1][0]]{ACTIONS})
			        or  not exists($$states[$$stack[-1][0]]{ACTIONS}{error})
					or	$$states[$$stack[-1][0]]{ACTIONS}{error} <= 0)) {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Pop state $$stack[-1][0].\n";

			pop(@$stack);
		}

			@$stack
		or	do {

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**No state left on stack: aborting.\n";

			return(undef);
		};

		#shift the error token

#DBG>			$debug & 0x10
#DBG>		and	print STDERR "**Shift \$error token and go to state ".
#DBG>						 $$states[$$stack[-1][0]]{ACTIONS}{error}.
#DBG>						 ".\n";

		push(@$stack, [ $$states[$$stack[-1][0]]{ACTIONS}{error}, undef ]);

    }

    #never reached
	croak("Error in driver logic. Please, report it as a BUG");

}#_Parse
#DO NOT remove comment

1;

}
#End of include--------------------------------------------------


#line 26 "AlgaeParser.yp"

    BEGIN {unshift@INC,('../..');}
    use W3C::Util::YappDriver;
    @ISA= qw (W3C::Util::YappDriver);

    use W3C::Rdf::AlgaeCompileTree;


sub new {
        my($class)=shift;
        ref($class)
    and $class=ref($class);

    my($self)=$class->SUPER::new( yyversion => '1.05',
                                  yystates =>
[
	{#State 0
		DEFAULT => -2,
		GOTOS => {
			'input' => 2,
			'@1-0' => 1,
			'cmnds' => 3
		}
	},
	{#State 1
		DEFAULT => -4,
		GOTOS => {
			'actionStar' => 4
		}
	},
	{#State 2
		ACTIONS => {
			'' => 5
		}
	},
	{#State 3
		DEFAULT => -1
	},
	{#State 4
		ACTIONS => {
			"assert" => 21,
			"quit" => 22,
			"\@" => 8,
			"attach" => 7,
			"fwrule" => 6,
			"flags" => 24,
			"ns" => 13,
			"ask" => 28,
			"clear" => 27,
			"slurp" => 16,
			"host" => 17,
			"collect" => 19,
			"select" => 29
		},
		DEFAULT => -3,
		GOTOS => {
			'quit' => 23,
			'actionStr' => 9,
			'collectStr' => 25,
			'clear' => 10,
			'fwRuleStr' => 26,
			'assertStr' => 12,
			'namespaceStr' => 11,
			'askStr' => 14,
			'flagsStr' => 15,
			'hostStr' => 18,
			'attachStr' => 30,
			'slurpStr' => 20
		}
	},
	{#State 5
		DEFAULT => 0
	},
	{#State 6
		ACTIONS => {
			"assert" => 21,
			"ask" => 28
		},
		GOTOS => {
			'askStr' => 32,
			'assertStr' => 31
		}
	},
	{#State 7
		DEFAULT => -26,
		GOTOS => {
			'@8-1' => 33
		}
	},
	{#State 8
		DEFAULT => -6,
		GOTOS => {
			'@2-2' => 34
		}
	},
	{#State 9
		DEFAULT => -5
	},
	{#State 10
		DEFAULT => -12
	},
	{#State 11
		DEFAULT => -17
	},
	{#State 12
		DEFAULT => -10
	},
	{#State 13
		DEFAULT => -45,
		GOTOS => {
			'@19-1' => 35
		}
	},
	{#State 14
		DEFAULT => -9
	},
	{#State 15
		DEFAULT => -13
	},
	{#State 16
		DEFAULT => -47,
		GOTOS => {
			'@20-1' => 36
		}
	},
	{#State 17
		DEFAULT => -36,
		GOTOS => {
			'@14-1' => 37
		}
	},
	{#State 18
		DEFAULT => -16
	},
	{#State 19
		ACTIONS => {
			"(" => 38
		}
	},
	{#State 20
		DEFAULT => -18
	},
	{#State 21
		DEFAULT => -23,
		GOTOS => {
			'@6-1' => 39
		}
	},
	{#State 22
		DEFAULT => -51
	},
	{#State 23
		DEFAULT => -19
	},
	{#State 24
		ACTIONS => {
			"-" => 40,
			"+" => 41
		},
		DEFAULT => -107,
		GOTOS => {
			'setOp' => 42
		}
	},
	{#State 25
		DEFAULT => -15
	},
	{#State 26
		DEFAULT => -14
	},
	{#State 27
		DEFAULT => -29
	},
	{#State 28
		DEFAULT => -20,
		GOTOS => {
			'@4-1' => 43
		}
	},
	{#State 29
		ACTIONS => {
			"(" => 44
		}
	},
	{#State 30
		DEFAULT => -11
	},
	{#State 31
		ACTIONS => {
			"ask" => 28
		},
		GOTOS => {
			'askStr' => 45
		}
	},
	{#State 32
		ACTIONS => {
			"assert" => 21
		},
		GOTOS => {
			'assertStr' => 46
		}
	},
	{#State 33
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		GOTOS => {
			'variable' => 47,
			'qname' => 53,
			'url' => 49,
			'urlvar' => 48
		}
	},
	{#State 34
		ACTIONS => {
			'URL' => 50,
			'FILE' => 54,
			'VAR' => 52
		},
		GOTOS => {
			'filename' => 57,
			'qname' => 53,
			'url' => 55,
			'sourceStr' => 56
		}
	},
	{#State 35
		ACTIONS => {
			'URL' => 50,
			'VAR' => 61
		},
		GOTOS => {
			'qname' => 53,
			'name' => 59,
			'url' => 58,
			'namespaceDecl' => 60
		}
	},
	{#State 36
		ACTIONS => {
			'URL' => 50,
			'FILE' => 54,
			'VAR' => 52
		},
		GOTOS => {
			'filename' => 57,
			'qname' => 53,
			'url' => 55,
			'sourceStr' => 62
		}
	},
	{#State 37
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		DEFAULT => -140,
		GOTOS => {
			'dbSpec' => 64,
			'variable' => 63,
			'qname' => 53,
			'url' => 65,
			'optDbSpec' => 66
		}
	},
	{#State 38
		DEFAULT => -30,
		GOTOS => {
			'@10-2' => 67
		}
	},
	{#State 39
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		DEFAULT => -140,
		GOTOS => {
			'dbSpec' => 64,
			'variable' => 63,
			'qname' => 53,
			'url' => 65,
			'optDbSpec' => 68
		}
	},
	{#State 40
		DEFAULT => -109
	},
	{#State 41
		DEFAULT => -108
	},
	{#State 42
		ACTIONS => {
			"(" => 69
		}
	},
	{#State 43
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		DEFAULT => -140,
		GOTOS => {
			'dbSpec' => 64,
			'variable' => 63,
			'qname' => 53,
			'url' => 65,
			'optDbSpec' => 70
		}
	},
	{#State 44
		DEFAULT => -33,
		GOTOS => {
			'@12-2' => 71
		}
	},
	{#State 45
		DEFAULT => -44
	},
	{#State 46
		DEFAULT => -43
	},
	{#State 47
		DEFAULT => -125
	},
	{#State 48
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"?" => 51,
			'INT' => 79,
			"%" => 72,
			'DtSTR' => 73,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 47,
			'urlvar' => 74,
			'literal' => 75,
			'urlvarlit' => 80,
			'internalName' => 81,
			'url' => 49,
			'qname' => 53
		}
	},
	{#State 49
		DEFAULT => -124
	},
	{#State 50
		DEFAULT => -145
	},
	{#State 51
		ACTIONS => {
			'VAR' => 82
		},
		GOTOS => {
			'variableName' => 83
		}
	},
	{#State 52
		ACTIONS => {
			":" => 84
		},
		DEFAULT => -148
	},
	{#State 53
		DEFAULT => -146
	},
	{#State 54
		DEFAULT => -144
	},
	{#State 55
		DEFAULT => -110
	},
	{#State 56
		DEFAULT => -7,
		GOTOS => {
			'@3-4' => 85
		}
	},
	{#State 57
		DEFAULT => -111
	},
	{#State 58
		DEFAULT => -106
	},
	{#State 59
		ACTIONS => {
			"=" => 86
		}
	},
	{#State 60
		DEFAULT => -46
	},
	{#State 61
		ACTIONS => {
			":" => 84,
			"=" => -139
		},
		DEFAULT => -148
	},
	{#State 62
		DEFAULT => -48,
		GOTOS => {
			'@21-3' => 87
		}
	},
	{#State 63
		DEFAULT => -143
	},
	{#State 64
		DEFAULT => -141
	},
	{#State 65
		DEFAULT => -142
	},
	{#State 66
		ACTIONS => {
			"(" => 88
		}
	},
	{#State 67
		ACTIONS => {
			"?" => 89
		},
		GOTOS => {
			'knownVar' => 90,
			'knownVars' => 91
		}
	},
	{#State 68
		ACTIONS => {
			"(" => 92
		}
	},
	{#State 69
		DEFAULT => -40,
		GOTOS => {
			'@17-3' => 93
		}
	},
	{#State 70
		ACTIONS => {
			"(" => 94
		}
	},
	{#State 71
		ACTIONS => {
			"?" => 89
		},
		GOTOS => {
			'knownVar' => 90,
			'knownVars' => 95
		}
	},
	{#State 72
		ACTIONS => {
			'VAR' => 97
		},
		GOTOS => {
			'name' => 96
		}
	},
	{#State 73
		ACTIONS => {
			'URL' => 50,
			'VAR' => 52
		},
		GOTOS => {
			'qname' => 53,
			'url' => 98
		}
	},
	{#State 74
		DEFAULT => -126
	},
	{#State 75
		DEFAULT => -127
	},
	{#State 76
		DEFAULT => -134
	},
	{#State 77
		DEFAULT => -136
	},
	{#State 78
		DEFAULT => -132
	},
	{#State 79
		DEFAULT => -133
	},
	{#State 80
		ACTIONS => {
			"(" => 99
		}
	},
	{#State 81
		DEFAULT => -128
	},
	{#State 82
		DEFAULT => -131
	},
	{#State 83
		DEFAULT => -129
	},
	{#State 84
		ACTIONS => {
			'VAR' => 100
		}
	},
	{#State 85
		DEFAULT => -8
	},
	{#State 86
		ACTIONS => {
			'URL' => 50,
			'VAR' => 52
		},
		GOTOS => {
			'qname' => 53,
			'url' => 101
		}
	},
	{#State 87
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		DEFAULT => -140,
		GOTOS => {
			'dbSpec' => 64,
			'variable' => 63,
			'qname' => 53,
			'url' => 65,
			'optDbSpec' => 102
		}
	},
	{#State 88
		DEFAULT => -37,
		GOTOS => {
			'@15-4' => 103
		}
	},
	{#State 89
		ACTIONS => {
			'VAR' => 82
		},
		GOTOS => {
			'variableName' => 104
		}
	},
	{#State 90
		DEFAULT => -103
	},
	{#State 91
		ACTIONS => {
			"?" => 89,
			")" => 105
		},
		GOTOS => {
			'knownVar' => 106
		}
	},
	{#State 92
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52,
			"[" => 109
		},
		GOTOS => {
			'declList' => 111,
			'decl' => 108,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'urlvar' => 107
		}
	},
	{#State 93
		DEFAULT => -101,
		GOTOS => {
			'bindingStar' => 112
		}
	},
	{#State 94
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 118,
			'urlvar' => 107
		}
	},
	{#State 95
		ACTIONS => {
			"?" => 89,
			")" => 119
		},
		GOTOS => {
			'knownVar' => 106
		}
	},
	{#State 96
		DEFAULT => -123
	},
	{#State 97
		DEFAULT => -139
	},
	{#State 98
		DEFAULT => -135
	},
	{#State 99
		DEFAULT => -101,
		GOTOS => {
			'bindingStar' => 120
		}
	},
	{#State 100
		DEFAULT => -147
	},
	{#State 101
		DEFAULT => -105
	},
	{#State 102
		ACTIONS => {
			"(" => 121
		}
	},
	{#State 103
		ACTIONS => {
			"?" => 89
		},
		GOTOS => {
			'knownVar' => 90,
			'knownVars' => 122
		}
	},
	{#State 104
		DEFAULT => -130
	},
	{#State 105
		DEFAULT => -31,
		GOTOS => {
			'@11-5' => 123
		}
	},
	{#State 106
		DEFAULT => -104
	},
	{#State 107
		DEFAULT => -112
	},
	{#State 108
		DEFAULT => -52
	},
	{#State 109
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		DEFAULT => -117,
		GOTOS => {
			'variable' => 47,
			'nulPropValList' => 127,
			'propValueList' => 125,
			'qname' => 53,
			'url' => 49,
			'property' => 126,
			'urlvar' => 124
		}
	},
	{#State 110
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		GOTOS => {
			'variable' => 47,
			'propValueList' => 128,
			'qname' => 53,
			'url' => 49,
			'property' => 126,
			'urlvar' => 124
		}
	},
	{#State 111
		ACTIONS => {
			"." => 130,
			")" => 129
		}
	},
	{#State 112
		ACTIONS => {
			'VAR' => 97,
			"%" => 72,
			")" => 132
		},
		GOTOS => {
			'internalName' => 134,
			'name' => 133,
			'binding' => 131
		}
	},
	{#State 113
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 135,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'urlvar' => 107
		}
	},
	{#State 114
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52,
			"[" => 109
		},
		GOTOS => {
			'decl' => 136,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'urlvar' => 107
		}
	},
	{#State 115
		DEFAULT => -66
	},
	{#State 116
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 137,
			'urlvar' => 107
		}
	},
	{#State 117
		DEFAULT => -60
	},
	{#State 118
		ACTIONS => {
			"|&" => 139,
			"||" => 140,
			"|-" => 138,
			"." => 142
		},
		DEFAULT => -70,
		GOTOS => {
			'dotOpt' => 141
		}
	},
	{#State 119
		DEFAULT => -34,
		GOTOS => {
			'@13-5' => 143
		}
	},
	{#State 120
		ACTIONS => {
			'VAR' => 97,
			"%" => 72,
			")" => 144
		},
		GOTOS => {
			'internalName' => 134,
			'name' => 133,
			'binding' => 131
		}
	},
	{#State 121
		DEFAULT => -101,
		GOTOS => {
			'bindingStar' => 145
		}
	},
	{#State 122
		ACTIONS => {
			"?" => 89,
			")" => 146
		},
		GOTOS => {
			'knownVar' => 106
		}
	},
	{#State 123
		DEFAULT => -32
	},
	{#State 124
		DEFAULT => -114
	},
	{#State 125
		ACTIONS => {
			";" => 147,
			"." => 148
		},
		DEFAULT => -118
	},
	{#State 126
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"?" => 51,
			'INT' => 79,
			"%" => 72,
			'DtSTR' => 73,
			'VAR' => 52,
			"[" => 149,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 47,
			'value' => 150,
			'urlvar' => 74,
			'literal' => 75,
			'urlvarlit' => 151,
			'valueList' => 152,
			'internalName' => 81,
			'qname' => 53,
			'url' => 49
		}
	},
	{#State 127
		ACTIONS => {
			"]" => 153
		}
	},
	{#State 128
		ACTIONS => {
			";" => 154
		},
		DEFAULT => -55
	},
	{#State 129
		DEFAULT => -24,
		GOTOS => {
			'@7-6' => 155
		}
	},
	{#State 130
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52,
			"[" => 109
		},
		DEFAULT => -53,
		GOTOS => {
			'decl' => 156,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'urlvar' => 107
		}
	},
	{#State 131
		DEFAULT => -102
	},
	{#State 132
		DEFAULT => -41,
		GOTOS => {
			'@18-6' => 157
		}
	},
	{#State 133
		ACTIONS => {
			"=" => 158
		}
	},
	{#State 134
		ACTIONS => {
			"=" => 159
		}
	},
	{#State 135
		DEFAULT => -68
	},
	{#State 136
		DEFAULT => -69
	},
	{#State 137
		ACTIONS => {
			"|&" => 139,
			"||" => 140,
			"|-" => 138,
			"." => 142
		},
		DEFAULT => -70,
		GOTOS => {
			'dotOpt' => 160
		}
	},
	{#State 138
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 161,
			'urlvar' => 107
		}
	},
	{#State 139
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 162,
			'urlvar' => 107
		}
	},
	{#State 140
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 163,
			'urlvar' => 107
		}
	},
	{#State 141
		ACTIONS => {
			")" => 164
		}
	},
	{#State 142
		ACTIONS => {
			'URL' => 50,
			"||" => 165,
			"?" => 51,
			"~" => 113,
			"!" => 114,
			"(" => 116,
			'VAR' => 52,
			"[" => 109
		},
		DEFAULT => -71,
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 166,
			'urlvar' => 107
		}
	},
	{#State 143
		DEFAULT => -35
	},
	{#State 144
		DEFAULT => -27,
		GOTOS => {
			'@9-7' => 167
		}
	},
	{#State 145
		ACTIONS => {
			'VAR' => 97,
			"%" => 72,
			")" => 168
		},
		GOTOS => {
			'internalName' => 134,
			'name' => 133,
			'binding' => 131
		}
	},
	{#State 146
		DEFAULT => -38,
		GOTOS => {
			'@16-7' => 169
		}
	},
	{#State 147
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52,
			"." => 171
		},
		GOTOS => {
			'variable' => 47,
			'qname' => 53,
			'url' => 49,
			'property' => 170,
			'urlvar' => 124
		}
	},
	{#State 148
		DEFAULT => -119
	},
	{#State 149
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		DEFAULT => -117,
		GOTOS => {
			'variable' => 47,
			'nulPropValList' => 172,
			'propValueList' => 125,
			'qname' => 53,
			'url' => 49,
			'property' => 126,
			'urlvar' => 124
		}
	},
	{#State 150
		DEFAULT => -72,
		GOTOS => {
			'constraintStar' => 173
		}
	},
	{#State 151
		DEFAULT => -115
	},
	{#State 152
		ACTIONS => {
			"," => 174
		},
		DEFAULT => -56
	},
	{#State 153
		DEFAULT => -113
	},
	{#State 154
		ACTIONS => {
			'URL' => 50,
			"?" => 51,
			'VAR' => 52
		},
		GOTOS => {
			'variable' => 47,
			'qname' => 53,
			'url' => 49,
			'property' => 170,
			'urlvar' => 124
		}
	},
	{#State 155
		DEFAULT => -25
	},
	{#State 156
		DEFAULT => -54
	},
	{#State 157
		DEFAULT => -42
	},
	{#State 158
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"?" => 51,
			'INT' => 79,
			"%" => 72,
			'DtSTR' => 73,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 47,
			'urlvar' => 74,
			'literal' => 75,
			'urlvarlit' => 175,
			'internalName' => 81,
			'url' => 49,
			'qname' => 53
		}
	},
	{#State 159
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"?" => 51,
			'INT' => 79,
			"%" => 72,
			'DtSTR' => 73,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 47,
			'urlvar' => 74,
			'literal' => 75,
			'urlvarlit' => 176,
			'internalName' => 81,
			'url' => 49,
			'qname' => 53
		}
	},
	{#State 160
		ACTIONS => {
			")" => 177
		}
	},
	{#State 161
		ACTIONS => {
			"|-" => 138,
			"." => 178
		},
		DEFAULT => -64
	},
	{#State 162
		ACTIONS => {
			"|&" => 139,
			"|-" => 138,
			"." => 178
		},
		DEFAULT => -63
	},
	{#State 163
		ACTIONS => {
			"|&" => 139,
			"||" => 140,
			"|-" => 138,
			"." => 178
		},
		DEFAULT => -62
	},
	{#State 164
		DEFAULT => -21,
		GOTOS => {
			'@5-7' => 179
		}
	},
	{#State 165
		ACTIONS => {
			'URL' => 50,
			"(" => 116,
			"!" => 114,
			"?" => 51,
			'VAR' => 52,
			"~" => 113,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 180,
			'urlvar' => 107
		}
	},
	{#State 166
		ACTIONS => {
			"." => 178
		},
		DEFAULT => -61
	},
	{#State 167
		DEFAULT => -28
	},
	{#State 168
		DEFAULT => -49,
		GOTOS => {
			'@22-8' => 181
		}
	},
	{#State 169
		DEFAULT => -39
	},
	{#State 170
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"?" => 51,
			'INT' => 79,
			"%" => 72,
			'DtSTR' => 73,
			'VAR' => 52,
			"[" => 149,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 47,
			'value' => 150,
			'urlvar' => 74,
			'literal' => 75,
			'urlvarlit' => 151,
			'valueList' => 182,
			'internalName' => 81,
			'qname' => 53,
			'url' => 49
		}
	},
	{#State 171
		DEFAULT => -120
	},
	{#State 172
		ACTIONS => {
			"]" => 183
		}
	},
	{#State 173
		ACTIONS => {
			"{" => 184
		},
		DEFAULT => -58
	},
	{#State 174
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"?" => 51,
			'INT' => 79,
			"%" => 72,
			'DtSTR' => 73,
			'VAR' => 52,
			"[" => 149,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 47,
			'value' => 185,
			'urlvar' => 74,
			'literal' => 75,
			'urlvarlit' => 151,
			'internalName' => 81,
			'qname' => 53,
			'url' => 49
		}
	},
	{#State 175
		DEFAULT => -137
	},
	{#State 176
		DEFAULT => -138
	},
	{#State 177
		DEFAULT => -67
	},
	{#State 178
		ACTIONS => {
			'URL' => 50,
			"||" => 165,
			"?" => 51,
			"~" => 113,
			"!" => 114,
			"(" => 116,
			'VAR' => 52,
			"[" => 109
		},
		GOTOS => {
			'QTerm' => 117,
			'decl' => 115,
			'variable' => 47,
			'subject' => 110,
			'qname' => 53,
			'url' => 49,
			'QTermPlus' => 166,
			'urlvar' => 107
		}
	},
	{#State 179
		DEFAULT => -22
	},
	{#State 180
		ACTIONS => {
			"|&" => 139,
			"||" => 140,
			"|-" => 138,
			"." => 178
		},
		DEFAULT => -65
	},
	{#State 181
		DEFAULT => -50
	},
	{#State 182
		ACTIONS => {
			"," => 174
		},
		DEFAULT => -57
	},
	{#State 183
		DEFAULT => -116
	},
	{#State 184
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 191,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 185
		DEFAULT => -72,
		GOTOS => {
			'constraintStar' => 197
		}
	},
	{#State 186
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'single' => 199,
			'literal' => 189,
			'internalName' => 200,
			'str' => 78,
			'variable' => 198,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 187
		ACTIONS => {
			"\@" => -121,
			"=" => -121
		},
		DEFAULT => -98
	},
	{#State 188
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'single' => 201,
			'literal' => 189,
			'internalName' => 200,
			'str' => 78,
			'variable' => 198,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 189
		DEFAULT => -99
	},
	{#State 190
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'single' => 202,
			'literal' => 189,
			'internalName' => 200,
			'str' => 78,
			'variable' => 198,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 191
		ACTIONS => {
			"}" => 204,
			"-" => 203,
			"!=" => 212,
			"&&" => 214,
			"||" => 213,
			"<" => 205,
			"+" => 206,
			"&" => 215,
			"/" => 216,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"|" => 217,
			"^" => 210,
			"*" => 211,
			"<=" => 218,
			">" => 219
		}
	},
	{#State 192
		DEFAULT => -100
	},
	{#State 193
		ACTIONS => {
			"\@" => 220,
			"=" => 221
		}
	},
	{#State 194
		DEFAULT => -90
	},
	{#State 195
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 222,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 196
		ACTIONS => {
			"\@" => -122,
			"=" => -122
		},
		DEFAULT => -97
	},
	{#State 197
		ACTIONS => {
			"{" => 184
		},
		DEFAULT => -59
	},
	{#State 198
		DEFAULT => -98
	},
	{#State 199
		DEFAULT => -93
	},
	{#State 200
		DEFAULT => -97
	},
	{#State 201
		DEFAULT => -95
	},
	{#State 202
		DEFAULT => -94
	},
	{#State 203
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 223,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 204
		DEFAULT => -73
	},
	{#State 205
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 224,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 206
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 225,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 207
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 226,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 208
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 227,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 209
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 228,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 210
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 229,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 211
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 230,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 212
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 231,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 213
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 232,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 214
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 233,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 215
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 234,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 216
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 235,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 217
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 236,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 218
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 237,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 219
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 238,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 220
		ACTIONS => {
			'STR' => 77
		},
		GOTOS => {
			'str' => 239
		}
	},
	{#State 221
		ACTIONS => {
			'STR' => 77,
			'URL' => 50,
			"-" => 186,
			"?" => 51,
			'INT' => 79,
			"~" => 188,
			"%" => 72,
			'DtSTR' => 73,
			"(" => 195,
			"!" => 190,
			'VAR' => 52,
			'FLOAT' => 76
		},
		GOTOS => {
			'str' => 78,
			'variable' => 187,
			'literal' => 189,
			'varOrName' => 193,
			'single' => 194,
			'expr' => 240,
			'internalName' => 196,
			'qname' => 53,
			'url' => 192
		}
	},
	{#State 222
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"^" => 210,
			"*" => 211,
			")" => 241,
			"!=" => 212,
			"||" => 213,
			"&&" => 214,
			"&" => 215,
			"/" => 216,
			"|" => 217,
			"<=" => 218,
			">" => 219
		}
	},
	{#State 223
		ACTIONS => {
			"%" => 207,
			"*" => 211,
			"/" => 216
		},
		DEFAULT => -78
	},
	{#State 224
		ACTIONS => {
			"-" => 203,
			"+" => 206,
			"%" => 207,
			"*" => 211,
			"/" => 216
		},
		DEFAULT => -79
	},
	{#State 225
		ACTIONS => {
			"%" => 207,
			"*" => 211,
			"/" => 216
		},
		DEFAULT => -77
	},
	{#State 226
		DEFAULT => -76
	},
	{#State 227
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			">=" => 209,
			"*" => 211,
			"/" => 216,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -83
	},
	{#State 228
		ACTIONS => {
			"-" => 203,
			"+" => 206,
			"%" => 207,
			"*" => 211,
			"/" => 216
		},
		DEFAULT => -82
	},
	{#State 229
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"*" => 211,
			"!=" => 212,
			"&" => 215,
			"/" => 216,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -86
	},
	{#State 230
		DEFAULT => -74
	},
	{#State 231
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			">=" => 209,
			"*" => 211,
			"/" => 216,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -84
	},
	{#State 232
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"^" => 210,
			"*" => 211,
			"!=" => 212,
			"||" => 213,
			"&&" => 214,
			"&" => 215,
			"/" => 216,
			"|" => 217,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -89
	},
	{#State 233
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"^" => 210,
			"*" => 211,
			"!=" => 212,
			"&&" => 214,
			"&" => 215,
			"/" => 216,
			"|" => 217,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -88
	},
	{#State 234
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"*" => 211,
			"!=" => 212,
			"/" => 216,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -85
	},
	{#State 235
		DEFAULT => -75
	},
	{#State 236
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"*" => 211,
			"!=" => 212,
			"&" => 215,
			"/" => 216,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -87
	},
	{#State 237
		ACTIONS => {
			"-" => 203,
			"+" => 206,
			"%" => 207,
			"*" => 211,
			"/" => 216
		},
		DEFAULT => -81
	},
	{#State 238
		ACTIONS => {
			"-" => 203,
			"+" => 206,
			"%" => 207,
			"*" => 211,
			"/" => 216
		},
		DEFAULT => -80
	},
	{#State 239
		DEFAULT => -92
	},
	{#State 240
		ACTIONS => {
			"-" => 203,
			"<" => 205,
			"+" => 206,
			"%" => 207,
			"==" => 208,
			">=" => 209,
			"^" => 210,
			"*" => 211,
			"!=" => 212,
			"||" => 213,
			"&&" => 214,
			"&" => 215,
			"/" => 216,
			"|" => 217,
			"<=" => 218,
			">" => 219
		},
		DEFAULT => -91
	},
	{#State 241
		DEFAULT => -96
	}
],
                                  yyrules  =>
[
	[#Rule 0
		 '$start', 2, undef
	],
	[#Rule 1
		 'input', 1, undef
	],
	[#Rule 2
		 '@1-0', 0,
sub
#line 71 "AlgaeParser.yp"
{$_[0]->YYData->{my_DONE}=0}
	],
	[#Rule 3
		 'cmnds', 2,
sub
#line 72 "AlgaeParser.yp"
{$_[0]->YYData->{my_DONE}=1; $_[2]}
	],
	[#Rule 4
		 'actionStar', 0, undef
	],
	[#Rule 5
		 'actionStar', 2,
sub
#line 75 "AlgaeParser.yp"
{push (@{$_[1]}, $_[2]); $_[1]}
	],
	[#Rule 6
		 '@2-2', 0,
sub
#line 76 "AlgaeParser.yp"
{&FILE}
	],
	[#Rule 7
		 '@3-4', 0,
sub
#line 76 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 8
		 'actionStar', 5,
sub
#line 76 "AlgaeParser.yp"
{push (@{$_[1]}, $_[0]->YYData->{ALGAE2}->include($_[4])); $_[1]}
	],
	[#Rule 9
		 'actionStr', 1, undef
	],
	[#Rule 10
		 'actionStr', 1, undef
	],
	[#Rule 11
		 'actionStr', 1, undef
	],
	[#Rule 12
		 'actionStr', 1, undef
	],
	[#Rule 13
		 'actionStr', 1, undef
	],
	[#Rule 14
		 'actionStr', 1, undef
	],
	[#Rule 15
		 'actionStr', 1, undef
	],
	[#Rule 16
		 'actionStr', 1, undef
	],
	[#Rule 17
		 'actionStr', 1, undef
	],
	[#Rule 18
		 'actionStr', 1, undef
	],
	[#Rule 19
		 'actionStr', 1, undef
	],
	[#Rule 20
		 '@4-1', 0,
sub
#line 93 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 21
		 '@5-7', 0,
sub
#line 93 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 22
		 'askStr', 8,
sub
#line 94 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->ask($_[5], $_[3])}
	],
	[#Rule 23
		 '@6-1', 0,
sub
#line 96 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 24
		 '@7-6', 0,
sub
#line 96 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 25
		 'assertStr', 7,
sub
#line 97 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->assert($_[5], $_[3])}
	],
	[#Rule 26
		 '@8-1', 0,
sub
#line 99 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 27
		 '@9-7', 0,
sub
#line 99 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 28
		 'attachStr', 8,
sub
#line 100 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->attach($_[3], $_[4], $_[6])}
	],
	[#Rule 29
		 'clear', 1,
sub
#line 103 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->clear()}
	],
	[#Rule 30
		 '@10-2', 0,
sub
#line 105 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 31
		 '@11-5', 0,
sub
#line 105 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 32
		 'collectStr', 6,
sub
#line 106 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->collect($_[4])}
	],
	[#Rule 33
		 '@12-2', 0,
sub
#line 107 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 34
		 '@13-5', 0,
sub
#line 107 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 35
		 'collectStr', 6,
sub
#line 108 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->collect($_[4])}
	],
	[#Rule 36
		 '@14-1', 0,
sub
#line 110 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 37
		 '@15-4', 0,
sub
#line 110 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 38
		 '@16-7', 0,
sub
#line 110 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 39
		 'hostStr', 8,
sub
#line 111 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->host($_[6], $_[3])}
	],
	[#Rule 40
		 '@17-3', 0,
sub
#line 113 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 41
		 '@18-6', 0,
sub
#line 113 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 42
		 'flagsStr', 7,
sub
#line 114 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->flags($_[5], $_[2])}
	],
	[#Rule 43
		 'fwRuleStr', 3,
sub
#line 117 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->fwrule($_[2], $_[3])}
	],
	[#Rule 44
		 'fwRuleStr', 3,
sub
#line 119 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->fwrule($_[3], $_[2])}
	],
	[#Rule 45
		 '@19-1', 0,
sub
#line 121 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 46
		 'namespaceStr', 3,
sub
#line 122 "AlgaeParser.yp"
{&TOK; $_[0]->YYData->{ALGAE2}->namespace(@{$_[3]})}
	],
	[#Rule 47
		 '@20-1', 0,
sub
#line 124 "AlgaeParser.yp"
{&FILE}
	],
	[#Rule 48
		 '@21-3', 0,
sub
#line 124 "AlgaeParser.yp"
{&VAR}
	],
	[#Rule 49
		 '@22-8', 0,
sub
#line 124 "AlgaeParser.yp"
{&TOK}
	],
	[#Rule 50
		 'slurpStr', 9,
sub
#line 124 "AlgaeParser.yp"
{
    $_[0]->YYData->{ALGAE2}->slurp($_[3], $_[7], $_[5])}
	],
	[#Rule 51
		 'quit', 1,
sub
#line 127 "AlgaeParser.yp"
{exit}
	],
	[#Rule 52
		 'declList', 1,
sub
#line 132 "AlgaeParser.yp"
{$_[0]->newDecl($_[1])}
	],
	[#Rule 53
		 'declList', 2,
sub
#line 133 "AlgaeParser.yp"
{$_[1]}
	],
	[#Rule 54
		 'declList', 3,
sub
#line 134 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Conjunction($_[1], $_[0]->newDecl($_[3]), $_[0])}
	],
	[#Rule 55
		 'decl', 2,
sub
#line 136 "AlgaeParser.yp"
{[[$_[1], $_[2]]]}
	],
	[#Rule 56
		 'propValueList', 2,
sub
#line 138 "AlgaeParser.yp"
{[[$_[1], $_[2]]]}
	],
	[#Rule 57
		 'propValueList', 4,
sub
#line 139 "AlgaeParser.yp"
{push (@{$_[1]}, [$_[3], $_[4]]); $_[1]}
	],
	[#Rule 58
		 'valueList', 2,
sub
#line 141 "AlgaeParser.yp"
{[[$_[1], $_[2]]]}
	],
	[#Rule 59
		 'valueList', 4,
sub
#line 142 "AlgaeParser.yp"
{push (@{$_[1]}, [$_[3], $_[4]]); $_[1]}
	],
	[#Rule 60
		 'QTermPlus', 1, undef
	],
	[#Rule 61
		 'QTermPlus', 3,
sub
#line 149 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Conjunction($_[1], $_[3], $_[0])}
	],
	[#Rule 62
		 'QTermPlus', 3,
sub
#line 151 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::ShortcutDisjunction($_[1], $_[3], $_[0])}
	],
	[#Rule 63
		 'QTermPlus', 3,
sub
#line 153 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::UnionDisjunction($_[1], $_[3], $_[0])}
	],
	[#Rule 64
		 'QTermPlus', 3,
sub
#line 155 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::UnionDisjunctionMerge($_[1], $_[3], $_[0])}
	],
	[#Rule 65
		 'QTermPlus', 4,
sub
#line 157 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Disjunction($_[1], $_[4], $_[0])}
	],
	[#Rule 66
		 'QTerm', 1,
sub
#line 160 "AlgaeParser.yp"
{$_[0]->newDecl($_[1])}
	],
	[#Rule 67
		 'QTerm', 4,
sub
#line 162 "AlgaeParser.yp"
{$_[2]}
	],
	[#Rule 68
		 'QTerm', 2,
sub
#line 164 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Option($_[2], $_[0])}
	],
	[#Rule 69
		 'QTerm', 2,
sub
#line 166 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Negation($_[0]->newDecl($_[2]), $_[0])}
	],
	[#Rule 70
		 'dotOpt', 0, undef
	],
	[#Rule 71
		 'dotOpt', 1, undef
	],
	[#Rule 72
		 'constraintStar', 0, undef
	],
	[#Rule 73
		 'constraintStar', 4,
sub
#line 175 "AlgaeParser.yp"
{push (@{$_[1]}, new W3C::Rdf::AlgaeCompileTree::Constraint($_[3], $_[0])); $_[1]}
	],
	[#Rule 74
		 'expr', 3,
sub
#line 177 "AlgaeParser.yp"
{$_[1] * $_[3];}
	],
	[#Rule 75
		 'expr', 3,
sub
#line 178 "AlgaeParser.yp"
{($_[3] != 0) ? $_[1] / $_[3] : 0;}
	],
	[#Rule 76
		 'expr', 3,
sub
#line 179 "AlgaeParser.yp"
{($_[3] != 0) ? $_[1] % $_[3] : 0;}
	],
	[#Rule 77
		 'expr', 3,
sub
#line 180 "AlgaeParser.yp"
{$_[1] + $_[3];}
	],
	[#Rule 78
		 'expr', 3,
sub
#line 181 "AlgaeParser.yp"
{$_[1] - $_[3];}
	],
	[#Rule 79
		 'expr', 3,
sub
#line 184 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Lt($_[1], $_[3], $_[0])}
	],
	[#Rule 80
		 'expr', 3,
sub
#line 185 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Gt($_[1], $_[3], $_[0])}
	],
	[#Rule 81
		 'expr', 3,
sub
#line 186 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Le($_[1], $_[3], $_[0])}
	],
	[#Rule 82
		 'expr', 3,
sub
#line 187 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Ge($_[1], $_[3], $_[0])}
	],
	[#Rule 83
		 'expr', 3,
sub
#line 188 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Eq($_[1], $_[3], $_[0])}
	],
	[#Rule 84
		 'expr', 3,
sub
#line 190 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Ne($_[1], $_[3], $_[0])}
	],
	[#Rule 85
		 'expr', 3,
sub
#line 192 "AlgaeParser.yp"
{$_[1] & $_[3];}
	],
	[#Rule 86
		 'expr', 3,
sub
#line 193 "AlgaeParser.yp"
{$_[1] ^ $_[3];}
	],
	[#Rule 87
		 'expr', 3,
sub
#line 194 "AlgaeParser.yp"
{$_[1] | $_[3];}
	],
	[#Rule 88
		 'expr', 3,
sub
#line 195 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::And($_[1], $_[3], $_[0])}
	],
	[#Rule 89
		 'expr', 3,
sub
#line 196 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Or($_[1], $_[3], $_[0])}
	],
	[#Rule 90
		 'expr', 1,
sub
#line 199 "AlgaeParser.yp"
{$_[1];}
	],
	[#Rule 91
		 'expr', 3,
sub
#line 201 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Assign($_[1], $_[3], $_[0])}
	],
	[#Rule 92
		 'expr', 3,
sub
#line 202 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Glob($_[1], $_[3], $_[0])}
	],
	[#Rule 93
		 'single', 2,
sub
#line 205 "AlgaeParser.yp"
{-$_[2];}
	],
	[#Rule 94
		 'single', 2,
sub
#line 206 "AlgaeParser.yp"
{!$_[2];}
	],
	[#Rule 95
		 'single', 2,
sub
#line 207 "AlgaeParser.yp"
{~$_[2];}
	],
	[#Rule 96
		 'single', 3,
sub
#line 208 "AlgaeParser.yp"
{$_[2];}
	],
	[#Rule 97
		 'single', 1,
sub
#line 209 "AlgaeParser.yp"
{$_[1];}
	],
	[#Rule 98
		 'single', 1,
sub
#line 210 "AlgaeParser.yp"
{$_[1];}
	],
	[#Rule 99
		 'single', 1,
sub
#line 211 "AlgaeParser.yp"
{$_[1];}
	],
	[#Rule 100
		 'single', 1,
sub
#line 212 "AlgaeParser.yp"
{$_[1];}
	],
	[#Rule 101
		 'bindingStar', 0, undef
	],
	[#Rule 102
		 'bindingStar', 2,
sub
#line 218 "AlgaeParser.yp"
{push (@{$_[1]}, $_[2]); $_[1]}
	],
	[#Rule 103
		 'knownVars', 1,
sub
#line 220 "AlgaeParser.yp"
{[$_[1]]}
	],
	[#Rule 104
		 'knownVars', 2,
sub
#line 221 "AlgaeParser.yp"
{push (@{$_[1]}, $_[2]); $_[1]}
	],
	[#Rule 105
		 'namespaceDecl', 3,
sub
#line 223 "AlgaeParser.yp"
{[$_[1], $_[3]]}
	],
	[#Rule 106
		 'namespaceDecl', 1,
sub
#line 224 "AlgaeParser.yp"
{['', $_[1]]}
	],
	[#Rule 107
		 'setOp', 0, undef
	],
	[#Rule 108
		 'setOp', 1, undef
	],
	[#Rule 109
		 'setOp', 1, undef
	],
	[#Rule 110
		 'sourceStr', 1, undef
	],
	[#Rule 111
		 'sourceStr', 1, undef
	],
	[#Rule 112
		 'subject', 1, undef
	],
	[#Rule 113
		 'subject', 3, undef
	],
	[#Rule 114
		 'property', 1, undef
	],
	[#Rule 115
		 'value', 1, undef
	],
	[#Rule 116
		 'value', 3,
sub
#line 242 "AlgaeParser.yp"
{
		    my $node = new W3C::Rdf::AlgaeCompileTree::BNode($_[0]);
		    [$node, $_[0]->newDecl([[$node, $_[2]]])];
		}
	],
	[#Rule 117
		 'nulPropValList', 0, undef
	],
	[#Rule 118
		 'nulPropValList', 1, undef
	],
	[#Rule 119
		 'nulPropValList', 2, undef
	],
	[#Rule 120
		 'nulPropValList', 3, undef
	],
	[#Rule 121
		 'varOrName', 1, undef
	],
	[#Rule 122
		 'varOrName', 1, undef
	],
	[#Rule 123
		 'internalName', 2,
sub
#line 255 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::KeyName($_[2], 1, $_[0])}
	],
	[#Rule 124
		 'urlvar', 1, undef
	],
	[#Rule 125
		 'urlvar', 1, undef
	],
	[#Rule 126
		 'urlvarlit', 1, undef
	],
	[#Rule 127
		 'urlvarlit', 1, undef
	],
	[#Rule 128
		 'urlvarlit', 1, undef
	],
	[#Rule 129
		 'variable', 2,
sub
#line 264 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Var($_[2], 1, $_[0])}
	],
	[#Rule 130
		 'knownVar', 2,
sub
#line 266 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Var($_[2], 0, $_[0])}
	],
	[#Rule 131
		 'variableName', 1, undef
	],
	[#Rule 132
		 'literal', 1, undef
	],
	[#Rule 133
		 'literal', 1,
sub
#line 271 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Int($_[1], $_[0])}
	],
	[#Rule 134
		 'literal', 1,
sub
#line 272 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Float($_[1], $_[0])}
	],
	[#Rule 135
		 'literal', 2,
sub
#line 273 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Literal($_[1], $_[2], $_[0])}
	],
	[#Rule 136
		 'str', 1,
sub
#line 275 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Literal($_[1], undef, $_[0])}
	],
	[#Rule 137
		 'binding', 3,
sub
#line 277 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Binding($_[1], $_[3], $_[0])}
	],
	[#Rule 138
		 'binding', 3,
sub
#line 278 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Binding($_[1], $_[3], $_[0])}
	],
	[#Rule 139
		 'name', 1, undef
	],
	[#Rule 140
		 'optDbSpec', 0, undef
	],
	[#Rule 141
		 'optDbSpec', 1,
sub
#line 283 "AlgaeParser.yp"
{$_[0]->YYData->{ALGAE2}->getSourceByName($_[1])}
	],
	[#Rule 142
		 'dbSpec', 1, undef
	],
	[#Rule 143
		 'dbSpec', 1, undef
	],
	[#Rule 144
		 'filename', 1,
sub
#line 288 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Url("file:$_[1]", $_[0])}
	],
	[#Rule 145
		 'url', 1,
sub
#line 290 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::Url($_[1], $_[0])}
	],
	[#Rule 146
		 'url', 1, undef
	],
	[#Rule 147
		 'qname', 3,
sub
#line 293 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::QName($_[1], $_[3], $_[0])}
	],
	[#Rule 148
		 'qname', 1,
sub
#line 294 "AlgaeParser.yp"
{new W3C::Rdf::AlgaeCompileTree::QName('',    $_[1], $_[0])}
	]
],
                                  @_);
    bless($self,$class);
}

#line 298 "AlgaeParser.yp"


BEGIN {unshift@INC,('../..');}
use W3C::Util::Exception qw(&throw &catch);

use vars qw($PUNCT $TOKEN $VAR $FILE $URL $DBSPEC);
($PUNCT, $TOKEN, $VAR, $FILE, $URL, $DBSPEC) = (0, \ "TOKEN", \ "VAR", \ "PREFIX", \ "URL", 5);

sub TOK {$_[0]->YYData->{NEXT} = $TOKEN}
sub VAR {$_[0]->YYData->{NEXT} = $VAR}
sub FILE {$_[0]->YYData->{NEXT} = $FILE}

sub _Error {
    my ($self) = @_;
    if (exists $self->YYData->{EXCEPTION}) {
	&throw($self->YYData->{EXCEPTION});
    }
    if (exists $self->YYData->{ERRMSG}) {
	&throw(new W3C::Util::YappDriver::GrammarException(-message => $self->YYData->{ERRMSG}, 
							   -location => $self->YYData->{LOCATION}));
        delete $self->YYData->{ERRMSG};
        return;
    }
    &throw(new W3C::Util::YappDriver::MesgYappContextException($self, -location => $self->YYData->{LOCATION}));
    my $trimmed = $self->YYData->{INPUT};
    $trimmed =~ s/[\r\n]*\Z//m;

    my ($token, $value, $expect, $data) = ($self->YYCurtok(), $self->YYCurval(), $self->YYExpect(), $self->YYData);
    my $tokenStr = defined $token && $token ne $value ? "$token " : '';
    my $valueStr = defined $value ? "'$value'" : 'EOF';
    my $dataStr = ref $data eq 'HASH' ? join ("\n", map {"$_: $data->{$_}"} keys %$data) : $data;
    $dataStr = substr($trimmed, $self->YYData->{my_LASTPOS}, 20);
    print "expected '$expect', got $tokenStr$valueStr at \"$dataStr\"\n";

    my $before = substr($trimmed, 0, $self->YYData->{my_LASTPOS}+1);
    $before =~ m/([^\r\n]*)\Z/m;
    my $column = length ($1) - 1;
    my $after = substr($trimmed, $self->YYData->{my_LASTPOS}+1);

    $after =~ m/([^\r\n]*)[\r\n]?(.*)/s;
    my ($line, $last) = ($1, $2);
    print "$before$line\n";
    print '=' x $column, "^\n";
    print "$last\n" if ($last);
    foreach my $entry (@{$self->{STACK}}) {
	print join (' | ', @$entry),"\n";
    }
}

sub _Lexer {
    my($self)=shift;

    if (defined $self->YYData->{INPUT} && pos $self->YYData->{INPUT} < length ($self->YYData->{INPUT})) {
    } else {
	if ($self->YYData->{my_DONE}) {
	    return ('', undef);
	}
	if (0) {
	if (!($self->YYData->{INPUT} = $self->nextChunk())) {
	    undef $self->YYData->{INPUT};
	    return ('', undef);
	}
	} else {
	my $pos = pos $self->YYData->{INPUT};
	my $chunk = $self->nextChunk();
	#print "\nchunk: $chunk\n";
	if (!$chunk) {
	    undef $self->YYData->{INPUT};
	    return ('', undef);
	}
	$self->YYData->{INPUT} .= $chunk;
	pos $self->YYData->{INPUT} = $pos;
	}
	#my $txt = $self->YYData->{INPUT};
	#print "\ntxt: $txt\n";
    }

    my ($token, $value) = ('', undef);
    while ($self->YYData->{INPUT} =~ m/\G\s*\#[^\n]*\n/gc) {}
    $self->YYData->{INPUT} =~ m/\G\s*/gc;
    $self->YYData->{my_LASTPOS} = pos $self->YYData->{INPUT};
    my $expect = $self->YYData->{NEXT};
    if (($expect == $VAR || $expect == $FILE) && $self->YYData->{INPUT} =~ m/\G\<\s*([^\s\>]+)\s*\>/gc) {
	($token, $value) = ('URL',$1);
    } elsif ($expect == $VAR && ($self->YYData->{INPUT} =~ m/\G\"([^\"]+)\"/gc || 
				 $self->YYData->{INPUT} =~ m/\G\'([^\']+)\'/gc)) {
	$value = $1;
	if ($self->YYData->{INPUT} =~ m/\G\s*\^\^/gc) {
	    $token = 'DtSTR';
	} else {
	    $token = 'STR';
	}
    } elsif ($self->YYData->{INPUT} =~ m/\G((?:[0-9]+)?\.[0-9]+)/gc) {
	($token, $value) = ('FLOAT',$1);
    } elsif ($self->YYData->{INPUT} =~ m/\G([0-9]+)/gc) {
	($token, $value) = ('INT',$1);
    } elsif ($self->YYData->{INPUT} =~ m/\G([A-Za-z][A-Za-z0-9_-]*)/gc) {
	($token, $value) = ($expect == $TOKEN ? $1 : $$expect ,$1);
    # very pathetic attempt at a file regexp
    } elsif ($expect == $FILE && $self->YYData->{INPUT} =~ m/\G([\.\;\~\|\&\w\/\+\-]+)/gc) {
	($token, $value) = ('FILE',$1);
    } elsif ($self->YYData->{INPUT} =~ m/\G(==|\!=|<=|>=|\|\||\|\&|\|\-|\&\&)/gc) {
	($token, $value) = ($1,$1);
    } elsif ($self->YYData->{INPUT} =~ m/\G(.)/gc) {
	($token, $value) = ($1,$1);
    }
    my $pos = pos $self->YYData->{INPUT};
    #print "\n$pos,$token,$value\n";
    return ($token, $value);
}

sub parse {
    my ($self, @args) = @_;
    $self->YYData->{NEXT} = $TOKEN;
    return $self->SUPER::parse(@args);
}

# Provide (one) chunk of text to parse.
sub nextChunk {
    my ($self) = @_;
    #return shift (@{$self->YYData->{my_CHUNKS}});
    #return shift (@ARGV);
    return <STDIN>;
}

# Handy debugging wrapper for calling semantics actions.
sub _wrap {
    my ($self, $obj, $method, @args) = @_;
    my @ret;
    eval {
	@ret = $obj->$method(@args);
    }; if ($@) {if (my $ex = &catch('W3C::Util::CachedContextException')) {
	&throw($ex);;
    } elsif ($ex = &catch('W3C::Util::Exception')) {
	my $newEx = new W3C::Util::CachedContextException(-str => $self->YYData->{INPUT}, 
							  -pos => $self->YYData->{my_LASTPOS}+1, 
							  -errorMessage => $ex->toString);
	$newEx->assumeStackTrace($ex);
	&throw($newEx);
    } else {
	my $newEx = new W3C::Util::CachedContextException(-str => $self->YYData->{INPUT}, 
							  -pos => $self->YYData->{my_LASTPOS}+1, 
							  -errorMessage => "$obj->$method: $@");
	&throw($newEx);
    }}
    return wantarray ? @ret : $ret[-1];
}

sub printArgs {
    return;
    print ':';
    foreach my $arg (@_) {
	print " $arg";
    }
    print ' Curtok:',$_[0]->YYCurtok;
    print ' Curval:',$_[0]->YYCurval;
    print ' Expect:',$_[0]->YYExpect;
    print ' Lexer:',$_[0]->YYLexer;
    print ' Data:',$_[0]->YYData;
    print "\n";
}

# Used by -M invocation:
#   perl -MW3C::Rdf::AlgaeParser -e '(new W3C::Rdf::AlgaeRLParser())->Run' '...'
sub main {
    my ($self) = @_;
    $self->Run();
}

# <parser state support>
sub newDecl {
    my ($self, $parm) = @_;
    my $ret;
    foreach my $decl (@$parm) {
	my ($subject, $propValList) = @$decl;
	foreach my $propVal (@$propValList) {
	    my ($property, $valueList) = @$propVal;
	    foreach my $valuePair (@$valueList) {
		my ($value, $constraints) = @$valuePair;
		# print $subject->toString.' '.$property->toString.' '.$value->toString."\n";
		my $toAdd = [];
		if (ref $value eq 'ARRAY') {
		    # we've got an object and a bunch of Decls about that object.
		    $toAdd = [$value->[1]];
		    $value = $value->[0];
		}
		my $newTerm = new W3C::Rdf::AlgaeCompileTree::Decl([$property, $subject, $value], 
								 $constraints, $self);
		foreach my $term ($newTerm, @$toAdd) {
		    if ($ret) {
			$ret = new W3C::Rdf::AlgaeCompileTree::Conjunction($ret, $term, $self);
		    } else {
			$ret = $term;
		    }
		}
	    }
	}
    }
    return $ret;
}

# </parser state support>

package W3C::Rdf::SimpleAlgaeParser;
use vars qw(@ISA);
@ISA = qw(W3C::Rdf::AlgaeParser);
sub new {
    my ($proto, $algaeString, $algae2, $location, @yappParms) = @_;
    my $class = ref($proto) || $proto;
    my $self = $class->SUPER::new(@yappParms);
    $self->YYData->{ALGAE_STRING} = $algaeString;
    $self->YYData->{LOCATION} = $location;
 
    $self->YYData->{ALGAE2} = $algae2;
    return $self;
}

sub nextChunk {
    my ($self) = @_;
    my $ret = $self->YYData->{ALGAE_STRING};
    $self->YYData->{ALGAE_STRING} = undef;
    return $ret;
}

# Interactive ReadLine parser -- under development
package W3C::Rdf::AlgaeRLParser;
use W3C::Util::Exception;
use vars qw(@ISA);
@ISA = qw(W3C::Rdf::AlgaeParser);
sub new {
    my ($proto, @parms) = @_;
    my $class = ref($proto) || $proto;

    # Change the parser driver to the readline driver.
    @W3C::Rdf::AlgaeParser::ISA= qw (W3C::Util::rlDriver);

    my $self = $class->SUPER::new(@parms);
    $self->YYData->{ACTIONS} = [];
    return $self;
}

sub nextChunk {
    my ($self) = @_;
    my $ret = undef;
    if ($self->{rl_COMPLETE_MODE}) {
	if ($self->{rl_SO_FAR}) {
	    $ret = $self->{rl_SO_FAR};
	    $self->{rl_SO_FAR} = undef;
	    #print "nextChunk: $ret\n";
	}
    } else {
	if (@{$self->YYData->{my_CHUNKS}}) {
	    $ret = shift (@{$self->YYData->{my_CHUNKS}});
	} else {
	    #return shift (@ARGV);
	    $ret = $self->readline('')."\n";
	    #print "ret: $ret";
	}
    }
    return $ret;
}

sub main {
    my ($self) = @_;
    $self->Run();
    print $self->toString,"\n";
}

sub _Lexer {
    my ($self, @args) = @_;
    $self->SUPER::_Lexer(@args);
}
sub Run {
    my ($self, $yydebug) = @_;
    $self->initState($self);
    eval {
	$self->YYParse( yylex => \&_Lexer, yyerror => \&W3C::Util::YappDriver::_BuildOpts, yydebug => $yydebug );
    }; if ($@) {if (my $ex = &catch('W3C::Util::CachedContextException')) {
	&throw($ex);;
    } elsif ($ex = &catch('W3C::Util::Exception')) {
	my $newEx = new W3C::Util::CachedContextException(-str => $self->YYData->{INPUT}, 
							  -pos => $self->YYData->{my_LASTPOS}+1, 
							  -errorMessage => $ex->toString);
	$newEx->assumeStackTrace($ex);
	&throw($newEx);
    } else {
	my $newEx = new W3C::Util::CachedContextException(-str => $self->YYData->{INPUT}, 
							  -pos => $self->YYData->{my_LASTPOS}+1, 
							  -errorMessage => $@);
	&throw($newEx);
    }}
}

sub toString {
    my ($self) = @_;
    my @ret = ref $self;
    foreach my $action (@{$self->YYData->{ACTIONS}}) {
	push (@ret, $action->toString());
    }
    return join ("\n", @ret);
}

sub addAction {
    my ($self, $action) = @_;
    push (@{$self->YYData->{ACTIONS}}, $action);
}

# perl -MW3C::Rdf::AlgaeParser -e '(new W3C::Rdf::AlgaeRLParser())->Run' 'asdf'
# b /usr/share/perl5/Parse/Yapp/Driver.pm:343

##!/usr/bin/perl
#BEGIN {unshift@INC,('../..');}
#use W3C::Rdf::AlgaeParser;
#$p = new W3C::Rdf::AlgaeRLParser();
#$p->main;

#./AlgaeParser "(ask '(<ab:cd> (?asdf ?s ?o)) assert '(ef:gh (?a ?b ?c)))"

1;

__END__

=head1 NAME

W3C::Rdf::AlgaeParser - parse the algae2 language

=head1 SYNOPSIS

  use W3C::Rdf::AlgaeParser;
  my $p = new W3C::Rdf::SimpleAlgaeParser($algaeString, $algae2, "algae.txt");
  my $actions = $p->parse($debug);
  foreach my $action (@$actions) {
    $action->delayedEvaluate($self->{RESULT_SET});
  }
  return $self->getReport();

=head1 DESCRIPTION

The AlgaeParser module binds a yapp grammar to semantic actions that build an
AlgaeCompileTree. In general, client applicatiosn have no direct interaction
with AlgaeParser. Devlopers wishing to extend the Algae2 query language
  http://www.w3.org/2003/11/Algae2/

will need the perl yapp modules. The Makefile included with the W3C::Rdf CPAN
module has a target to re-compile the AlgaeParser grammar. Invoke this with
  make AlgaeParser.pm
It is likely that someone extending the AlgaeParser grammar will also want to
extended AlgaeCompileTree.

This module is part of the W3C::Rdf CPAN module.

=head1 AUTHOR

Eric Prud\'hommeaux <eric@w3.org>

=head1 SEE ALSO

W3C::Rdf::Algae2(3) W3C::Rdf::AlgaeCompileTree(3) perl(1).

=cut

1;
