# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

# Change 1..1 below to 1..last_test_to_print .
# (It may become useful if the test is moved to ./t subdirectory.)

use strict;
BEGIN { $| = 1; print "1..20\n"; }
use vars qw($loaded);
END {print "not ok 1\n" unless $loaded;}
use W3C::Rdf::Algae2;
$loaded = 1;
print "ok 1 use W3C::Rdf::Algae2\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

# Variables set by the configure script (perl Makefile.PL):
my $TEST_tripleStore = 1;
my $TEST_orderTracking = 1;
my $TEST_finger = 0;
my $utf8 = ''; # ':utf8';
# End of area that configure mucks with

my $testNo = 2;
my @coreTests = qw(Annotation0 RDQL0 SeRQL0 Disjunction0 Annotation0 Optional0 fwruleTest0 fwruleTest1 );
my @tsTests = qw(Annotation1 Annotation2 Annotation3 Annotation4 );
my @otTests = qw(OrderTracking0 OrderTracking1 OrderTracking3 OrderTracking4 OrderTracking5 OrderTracking6 Federate0 );
my @fingerTests = qw(Finger0 );
my @tests = @coreTests;
push (@tests, @tsTests) if ($TEST_tripleStore);
push (@tests, @otTests) if ($TEST_orderTracking);
push (@tests, @fingerTests) if ($TEST_finger);
foreach my $test (@tests) {
    &doTest($testNo++, "test/${test}-alg.sh");
}

sub doTest {
    my ($testNo, $test) = @_;
    local $/ = undef;
    if (!open (TEST, "<$utf8", $test)) {
	warn "can't open $test: $!";
	return;
    }
    my $script = <TEST>;
    close TEST;
    if ($script =~ m/\n\# Table Results:\n(.*?\n)\n/s) {
	my $expected = $1;
	$expected =~ s/^\# //gm;
	my $expectedS = &reorder($expected);
	my $run = "(cd bin && perl \"-I../blib/lib\" \"-I../blib/arch\" ./algae \@../$test)";
	if (!open (RUN, "-|$utf8", "$run")) {
	    warn "can't run $run: $!";
	    return;
	}
	my $out = <RUN>;
	close RUN;
	my $outS = &reorder($out);
	if ($outS ne $expectedS) {
	    warn "expected:\n$expectedS\n\ngot:\n$outS";
	    warn "not ok $testNo $test";
	}
	print "ok $testNo $test\n";
    } else {
	warn "unable to find \"# Table Results:\" in $test";
    }
}


sub reorder {
    my ($unsorted) = @_;
    $unsorted =~ s/\_\:g_(\d+)/\_\:g_X/;
    return join("\n", sort split (/\n/, $unsorted));
}

