#!/bin/sh

###############################################################################
# Copyright 2002 W3C (MIT, INRIA, Keio), All Rights Reserved.
# W3C liability, trademark, document use and software licensing rules apply.
# Written by Eric Prud'hommeaux for the World Wide Web Consortium
# 
# Annotations1 - Flexible Annotea query
# Tests:
#   - disjunction
#   - operator precedence (generating SQL query)
#   - utf-8
# 
# Part of W3C/Rdf/test perl library test suite.
# See http://www.w3.org/1999/02/26-modules/
# $Id: Annotation2-alg.sh,v 1.5 2004/06/18 10:47:00 eric Exp $
###############################################################################

algae $* \
-a"
ns rdfs=<http://www.w3.org/1999/02/22-rdf-syntax-ns#>
ns a=<http://www.w3.org/2000/10/annotation-ns#>
ns http=<http://www.w3.org/1999/xx/http#>
ns d0=<http://purl.org/dc/elements/1.0/>
ns d1=<http://purl.org/dc/elements/1.1/>
attach <http://www.w3.org/1999/02/26-modules/algae#dynamic> ?db (
                    class=\"W3C::Rdf::SqlDB\"
                    properties=\"../test/genericTripleStore.prop\")
slurp <../test/Annotation1052587433.529382.rdf> ?db ()
ns alg=<http://www.w3.org/1999/02/26-modules/algae#>
ask ?db (
       ?annotation rdfs:type a:Annotation {%ATTRIB == <../test/Annotation1052587433.529382.rdf>}.
       (?annotation d0:title ?title ||
        ?annotation d1:title ?title).
       (?annotation d0:creator ?creat ||
        ?annotation d1:creator ?creat).
       ?creat      a:Given ?given.
       ?annotation a:annotates ?annotates.
       ?annotation a:context ?context.
       ?annotation a:body ?body {%ATTRIB == <../test/Annotation1052587433.529382.rdf>}.
       ?body http:Body ?text
      )
select (?annotation ?body ?title ?given)
" \

# Table Results:
# +-------------------------------------------------------------+-------------------------------------------------------+-----------------------------------+----------+
# |                                                   annotation|                                                   body|                              title|     given|
# |-------------------------------------------------------------|-------------------------------------------------------|-----------------------------------|----------|
# |<http://iggy.w3.org/annotations/annotation/1052587433.529382>|<http://iggy.w3.org/annotations/body/1052587433.529382>|"Old Annotation of Eric's Homepage"|"É®íç"|
# |<http://iggy.w3.org/annotations/annotation/1054553215.108988>|<http://iggy.w3.org/annotations/body/1054553215.108988>|"New Annotation of Eric's Homepage"|"É®íç"|
# +-------------------------------------------------------------+-------------------------------------------------------+-----------------------------------+----------+

# SQL Query:

