#!/bin/sh

###############################################################################
# Copyright 2002 W3C (MIT, INRIA, Keio), All Rights Reserved.
# W3C liability, trademark, document use and software licensing rules apply.
# Written by Eric Prud'hommeaux for the World Wide Web Consortium
# 
# Disjunction0 - Single optional arc
# Tests:
#   - union disjunction with merge
# 
# Part of W3C/Rdf/test perl library test suite.
# See http://www.w3.org/1999/02/26-modules/
# $Id: Disjunction0-alg.sh,v 1.3 2004/06/17 15:55:29 eric Exp $
###############################################################################

algae $* \
-a"
ns <http://example.org/n#>
assert (
 A0 p1 B .
# A0 p2 C .
# A0 p3 D .

# A1 p1 B .
 A1 p2 C .
# A1 p3 D .

# A2 p1 B .
# A2 p2 C .
 A2 p3 D .

# A3 p1 B .
 A3 p2 C .
 A3 p3 D )

ask (
 ( ?n p2 C |- ?n p3 D ))

collect (?n)
" \

# Table Results:
# +-------------------------+
# |                        n|
# |-------------------------|
# |<http://example.org/n#A1>|
# |<http://example.org/n#A3>|
# |<http://example.org/n#A2>|
# +-------------------------+

