#!/bin/sh

###############################################################################
# Copyright 2002 W3C (MIT, INRIA, Keio), All Rights Reserved.
# W3C liability, trademark, document use and software licensing rules apply.
# Written by Eric Prud'hommeaux for the World Wide Web Consortium
# 
# OrderTracking0 - 
# 
# Part of W3C/Rdf/test perl library test suite.
# See http://www.w3.org/1999/02/26-modules/
# $Id: OrderTracking0-alg.sh,v 1.8 2004/06/18 10:47:00 eric Exp $
###############################################################################

algae $* \
-a"
ns ot=<http://localhost/OrderTracking#>
attach <http://www.w3.org/2003/01/21-RDF-RDB-access/ns#dbs> ot:db (
                    properties=\"../test/OrderTracking.prop\")
ask ot:db (
	?p	ot:Products_description	?productDesc
)
collect (?productDesc) 
" \
-a"
clear
ns ot=<http://localhost/OrderTracking#>
ask ot:db (
	?c	ot:Customers_familyName	?last .
	?c	ot:Customers_givenName	?first
)
collect (?first ?last) 
" \

# Table Results:
# +-----------------------+
# |            productDesc|
# |-----------------------|
# |          "white house"|
# |         "picket fence"|
# |"sport utility vehicle"|
# |                 "pool"|
# |                "grill"|
# |           "skateboard"|
# |      "rebelious music"|
# |              "earring"|
# |            "nose ring"|
# |           "other ring"|
# +-----------------------+
# +--------+----------+
# |   first|      last|
# |--------|----------|
# |  "Biff"|"Thompson"|
# |  "Chip"|"Thompson"|
# |"Eustis"|  "Walker"|
# |  "Elie"|   "Tweak"|
# +--------+----------+

